#ifndef _RTDS_SUT_INTERFACE_H_
#define _RTDS_SUT_INTERFACE_H_

#include "SIP_TypesAndConf.h"

#define UDP1 0
#define UDP2 1
#define UDP3 2
/*
#define TCP1 3
#define TCP2 4
#define TCP3 5
*/
  
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_UDP1(MESSAGE) \
  SUT_send(MESSAGE, NULL, UDP1);
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_UDP1(MESSAGE, ADDRESS) \
  SUT_send(MESSAGE, ADDRESS, UDP1);

#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_UDP2(MESSAGE) \
  SUT_send(MESSAGE, NULL, UDP2);
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_UDP2(MESSAGE, ADDRESS) \
  SUT_send(MESSAGE, ADDRESS, UDP2);

#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_UDP3(MESSAGE) \
  SUT_send(MESSAGE, NULL, UDP3);
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_UDP3(MESSAGE, ADDRESS) \
  SUT_send(MESSAGE, ADDRESS, UDP3);

#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TCP1(MESSAGE) \
  fprintf(stderr,"TCP connections are not supported!\n");
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_TCP1(MESSAGE, ADDRESS) \
  fprintf(stderr,"TCP connections are not supported!\n");

#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TCP2(MESSAGE) \
  fprintf(stderr,"TCP connections are not supported!\n");
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_TCP2(MESSAGE, ADDRESS) \
  fprintf(stderr,"TCP connections are not supported!\n");

#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TCP3(MESSAGE) \
  fprintf(stderr,"TCP connections are not supported!\n");
#define RTDS_TTCN_SEND_MESSAGE_VIA_TSI_PORT_TO_ADDRESS_TCP3(MESSAGE, ADDRESS) \
  fprintf(stderr,"TCP connections are not supported!\n");

#define RTDS_TTCN_EXTERNAL_ACTION(MESSAGE) \
  printf("%s\n" , MESSAGE);

#define RTDS_TTCN_LOG(TYPES,...) \
{ \
char * param = TYPES; \
int paramNB = strlen(TYPES); \
char * parameters = (char*)malloc(20*sizeof(char)); \
{ \
for (int i = 0;i<paramNB;i++) \
{ \
parameters[2*i]='%'; \
parameters[2*i+1]=param[i]; \
} \
} \
printf(parameters, __VA_ARGS__); \
printf("\n"); \
}

extern int SUT_init(void);

extern int SUT_clean(void);

extern void SUT_send(RTDS_MessageHeader *, address *, int );

#endif 
